//
// Copyright 2017 Google Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

NS_ASSUME_NONNULL_BEGIN

/**
 * Takes failure screenshots. It is called from multiple places where errors can be generated.
 */
@interface GREYFailureScreenshotter : NSObject

/**
 * @return An NSDictionary with the generated app screenshots.
 */
+ (NSDictionary<NSString *, UIImage *> *)screenshots;

@end

NS_ASSUME_NONNULL_END
